summaryrefslogtreecommitdiff
path: root/package/base-files/src/sbin
diff options
context:
space:
mode:
authorWaldemar Brodkorb <wbx@openadk.org>2010-02-07 20:03:20 +0100
committerWaldemar Brodkorb <wbx@openadk.org>2010-02-07 20:03:20 +0100
commit6daa792eab1488d013fefc5eb7e4d01f40f38687 (patch)
tree6391cc46bb9fc8b859d99175ea317e5fa7b37959 /package/base-files/src/sbin
parentadcaca72539b2ff4a5f4deee00d5f0251378ac9b (diff)
change defaults for CONFIG/BUILD/INSTALL styles
All packages need an update, so here is a very huge commit. Most of the 460 source packages use automatic style for configuration, building and installing. Make these styles default to "auto". If you have a package, which does not conform to this, just use manual style and add a do-$task make target. I added a new style named AUTOTOOL style, which is needed for some broken packages, which needs to be updated via autoconf or automake. I renamed CONFIGURE_STYLE to CONFIG_STYLE. Updates for some packages, which have newer upstream versions. Renaming of all package/*/extra directories. Use the directory src/ to provide overwrites of source files or to add the code, when no upstream package is available or used. src directory will be automatically used.
Diffstat (limited to 'package/base-files/src/sbin')
-rwxr-xr-xpackage/base-files/src/sbin/update75
1 files changed, 75 insertions, 0 deletions
diff --git a/package/base-files/src/sbin/update b/package/base-files/src/sbin/update
new file mode 100755
index 000000000..d41e23a0f
--- /dev/null
+++ b/package/base-files/src/sbin/update
@@ -0,0 +1,75 @@
+#!/bin/sh
+
+who=$(id -u)
+if [ $who -ne 0 ]; then
+ echo 'Exit. System update must be run as root.'
+ exit 1
+fi
+
+if [ -x /sbin/mtd ];then
+ updatecmd="mtd -r write - linux"
+else
+ updatecmd="gunzip -c | tar -xf -"
+fi
+
+check_exit() {
+ if [ $? -ne 0 ];then
+ echo "Update failed."
+ exit 1
+ fi
+}
+
+prepare() {
+ cd /
+ umount -f /etc
+ mount -o remount,rw /
+}
+
+extract_from_file() {
+ prepare
+ cat $1 | eval $updatecmd
+ check_exit
+}
+
+extract_from_ssh() {
+ prepare
+ ssh $1 "cat $2" | eval $updatecmd
+ check_exit
+}
+
+extract_from_http() {
+ prepare
+ wget -O - $1 | eval $updatecmd
+ check_exit
+}
+
+case $1 in
+ file://*|/*)
+ url=$(echo $1|sed -e "s#file://##")
+ echo "Updating system from $1"
+ extract_from_file $url
+ ;;
+ ssh://*)
+ host=$(echo $1|sed -e "s#ssh://\(.*\):.*#\1#")
+ file=$(echo $1|sed -e "s#ssh://.*:\(.*\)#\1#")
+ echo "Updating system from $1"
+ extract_from_ssh $host $file
+ ;;
+ http://*|ftp://*)
+ echo "Updating system from $1"
+ extract_from_http $1
+ ;;
+ *)
+ echo "No or wrong uri given. exit."
+ echo "Use one of the following uri:"
+ echo "http://myserver/myupdate.tar.gz"
+ echo "ssh://myuser@myserver:/my/path/myupdate.tar.gz"
+ echo "file:///mypath/myupdate.tar.gz"
+ exit 1
+ ;;
+esac
+
+sync
+mount -o bind /etc /tmp/.cfgfs/root
+
+echo "Update sucessful. You should reboot now."